﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CPMotor_DotNET;

namespace TorqueControl
{
    public partial class Form1 : Form
    {
        byte Slot = 0;
        byte Baud = 5;
        byte Type = 1;
        byte Id = 1;

        public Form1()
        {
            InitializeComponent();

            combo_slot.SelectedIndex = 0;
            combo_baud.SelectedIndex = 5;
            combo_motortype.SelectedIndex = 1;
            combo_motorid.SelectedIndex = 0;

            Slot = 0;
            Baud = 5;
            Type = 1;
            Id = 1;
        }

        private void combo_slot_SelectedIndexChanged(object sender, EventArgs e)
        {
            Slot = (byte)combo_slot.SelectedIndex;
        }

        private void combo_baud_SelectedIndexChanged(object sender, EventArgs e)
        {
             Baud = (byte)combo_baud.SelectedIndex;
        }

        private void combo_motortype_SelectedIndexChanged(object sender, EventArgs e)
        {
            Type = (byte)combo_motortype.SelectedIndex;
        }

        private void combo_motorid_SelectedIndexChanged(object sender, EventArgs e)
        {
            Id = (byte)(combo_motorid.SelectedIndex + 1);
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            UInt16 ret;

            ret = CPMotor.CPMotor_MotionStop(Slot, Id, 300);
            if (ret != 0)
            {
                MessageBox.Show("CPMotor_MotionStop Error " + ret.ToString());
            }
            else
            {
                ret = CPMotor.CPMotor_CloseMotor(Slot, Id);
                if (ret != 0)
                {
                    MessageBox.Show("CPMotor_CloseMotor Error " + ret.ToString());
                }
                else
                {
                    ret = CPMotor.CPMotor_ShutdownMaster(Slot);
                    if (ret != 0)
                    {
                        MessageBox.Show("CPMotor_ShutdownMaster Error " + ret.ToString());
                    }
                }
            }
        }

        private void btn_initial_Click(object sender, EventArgs e)
        {
            UInt16 ret;

            // CPMotor_InitMaster
            ret = CPMotor.CPMotor_InitMaster(CPMotor.MASTERMODULE.MASTER_MODULE_I8123W, Slot, (CPMotor.BAUDRATE)Baud);
            if (ret != 0)
            {
                MessageBox.Show("CPMotor_InitMaster Error " + ret.ToString());
            }
            else
            {
                // CPMotor_AddMotor
                ret = CPMotor.CPMotor_AddMotor(Slot, Id, 1, 200, (CPMotor.MOTOR_MANUFACTURER)Type);
                if (ret != 0)
                {
                    MessageBox.Show("CPMotor_AddMotor Error " + ret.ToString());
                }
                else
                {
                    ret = CPMotor.CPMotor_InitMotor(Slot, Id, 100);
                    if (ret != 0)
                    {
                        MessageBox.Show("CPMotor_InitMotor Error " + ret.ToString());
                    }
                    else
                    {
                        MessageBox.Show("AddMotor and InitMotor OK");

                        btn_initial.Enabled = false;

                        combo_slot.Enabled = false;
                        combo_baud.Enabled = false;
                        combo_motorid.Enabled = false;
                        combo_motortype.Enabled = false;

                        bar_wpos.Enabled = true;

                        timer1.Enabled = true;
                    }
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            UInt16 ret;
            int torque = 0;

            ret = CPMotor.CPMotor_PT_CurrentTorque(Slot, Id, ref torque);
            if (ret == 0)
            {
                text_rpos.Text = ((short)torque).ToString();
                bar_rpos.Value = (short)(torque);
            }
        }

        private void bar_wpos_ValueChanged(object sender, EventArgs e)
        {
            UInt16 ret;
            int tag_torque;

            tag_torque = bar_wpos.Value;
            text_wpos.Text = tag_torque.ToString();

            ret = CPMotor.CPMotor_PT_MotionMove(Slot, Id, (uint)Math.Abs(tag_torque / 10), tag_torque);
            if (ret != 0)
            {
                MessageBox.Show("CPMotor_PT_MotionMove Error " + ret.ToString());
            }
        }

    }
}